var dbp = {

	widget : function( i )
	{

		this.init = function( i )
		{
			this.i = i;


			this.id = ( this.i == 1 ) ? 'dashpress' : 'dashpress_'+this.i;


			this.widget 	= 'div#'+this.id;

			this.configure 	= this.widget + ' a.edit-box.open-box';
			this.cancel 	= this.widget + ' a.edit-box.close-box';

			this.inside 	= this.widget + ' div.inside';
			this.form 	= this.inside + ' form';
			this.norequest 	= this.inside + ' .widget-norequest';

			jQuery( this.configure ).after( '<a href="#" class="hidden edit-box close-box">'+dbpL10n.cancel+'</a>' );

			jQuery( this.configure ).click( function() {
				jQuery( this ).hide();
				_this.get_control();
				return false;
			});

			jQuery( this.cancel ).click( function() {
				jQuery( this ).hide();
				jQuery( _this.norequest ).removeClass( 'widget-norequest' );
				_this.get_content();
				return false;
			});

			this.get_content();
		};

		this.get_content = function()
		{
			if ( jQuery( this.norequest ).length ) return;					// in case configure form is on !

			var parms = { action: 'dbp_ajax', dbp_action: 'get_content', i: this.i };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: dbpL10n.url,
				success: function( data ) { _this.got_content( data ); } 
			});
		};

		this.got_content = function( data )
		{
			if ( jQuery( this.norequest ).length ) return;					// in case configure form is on !

			if ( (typeof data.empty !=='undefined') && data.empty )
			{
				jQuery( this.inside ).html( jQuery( '#tmpl-dbp-nocontent' ).html() );	// reset widget content (with (no)data)
			}
			else
			{
				var content = wp.template( 'dbp-content' );
				jQuery( this.inside ).html( content( data ) );
			}

			jQuery( this.configure ).show();
		};

		this.get_control = function()
		{
			jQuery( this.inside ).html( '<p class="widget-norequest"></p>' );

			var parms = { action: 'dbp_ajax', dbp_action: 'get_control', i: this.i };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: dbpL10n.url,
				success: function( data ) { _this.got_control( data ); } 
			});
		};

		this.got_control = function( data )
		{
			if ( data )
			{
				var control = wp.template( 'dbp-control' );
				jQuery( this.inside ).html( control( data ) );

				jQuery( this.form ).on( 'submit', function() {
					jQuery( this.form + ' input[type="submit"]' ).attr( 'disabled', 'disabled' );
					var form = jQuery( this );
					_this.control_submitted( form );
					return false;
				});
			}

			jQuery( this.cancel ).show();
		};

		this.control_submitted = function( form )
		{
			jQuery( this.cancel ).hide();

			var parms = { action: 'dbp_ajax', dbp_action: 'control_submitted', i: this.i, form: jQuery( form ).serialize() };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: dbpL10n.url,
				beforeSend: function( xhr ) {
					jQuery( this.inside ).html('');
				},
				success: function( data ) { 
					jQuery( _this.norequest ).removeClass( 'widget-norequest' ); 
					_this.got_content( data );
				} 
			});
		};

		var _this = this;			// _this is this ( oop ! )

		this.init( i );
	},

	init : function()
	{
		// creating widget instances
		for( i = 1; i <= dbpL10n.count; i++ ) new dbp.widget( i );


		// everything done ?
		if ( dbpL10n.can_edit != '1' ) return;

		// dashboard settings panel
		jQuery( '#dashboard-options-link-wrap' ).appendTo( '#screen-meta-links' );
		jQuery( '#dashboard-options-wrap' ).prependTo( '#screen-meta' );

		// toggle new panel
		jQuery( '#dashboard-options-link' ).on( 'focus.scroll-into-view', function( e ){
			if ( e.target.scrollIntoView ) e.target.scrollIntoView( false );
		});

		// new number of widget(s)
		jQuery( '.widgets-prefs input[type="radio"]' ).click( function(){
			var parms = { action: 'dbp_ajax', dbp_action: 'update_count', count: jQuery( this ).val() };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: dbpL10n.url
			});
		});

		// select/deselect a widget
		jQuery( '.hide-dashbox-tog' ).click( function() {

			var box = jQuery( this ).val();
			var checked = ( jQuery( this ).attr( 'checked' ) ) ? 1 : 0;

			var parms = { action: 'dbp_ajax', dbp_action: 'update_visible', checked: checked , box: box };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: dbpL10n.url
			});
		});

		// globalize settings
		jQuery( '#dashpress-global-settings' ).click( function() {

			var parms = { action: 'dbp_ajax', dbp_action: 'set_global' };

			jQuery.ajax({
				data: parms,
				type: "POST",
				url: dbpL10n.url,
				success: function( response ) {
					jQuery( '#dashpress-global-settings' ).attr( 'value', ( response == '1' ) ? dbpL10n.erase : dbpL10n.set );
				}
			});
		});
	}
};
jQuery( document ).ready( function() { dbp.init(); } );